require "open-uri" 
require 'net/http'
require "json"
require "thor"
require "csv"
require "rcbp/version"

def getPrice(url)
  amount = String.new
  currency = String.new

  open(url) do |d|
    json = JSON.parse(d.read)
    amount = json["amount"]
    currency = json["currency"]
  end
  
  return amount
end

def getSpotPrice
  return getPrice("https://api.coinbase.com/v1/prices/spot_rate")
end

def getBuyPrice
  return getPrice("https://api.coinbase.com/v1/prices/buy?qty=1")
end

def getSellPrice
  return getPrice("https://api.coinbase.com/v1/prices/sell?qty=1")
end

def getHistoricalPrice
  csv = String.new
  open("https://api.coinbase.com/v1/prices/historical") do |d|
    csv = CSV.parse(d.read, :col_sep => ",", :headers => "false")
    return csv[200][1]
  end
end

def colorize(text, color_code)
    "\e[#{color_code}m#{text}\e[0m"
end

def setColor(text)
  # If price went down, set text to red and vice versa to green
  if getHistoricalPrice.to_f >= getSpotPrice.to_f
    colorize(text, 31)
  else
    colorize(text, 32)
  end
end

